; DLL library template
format PE GUI 4.0 DLL
entry DllEntryPoint

include '%finc%/win32/win32a.inc'


struc db [data]
  {
        common
        . db data
        .size = $ - .
  }


; Description of the binary;
; NOTE: those are Unicode strings, and they get placed in the .rsrc section
; However, the null terminator must be omitted

Comments                equ     'Contains various post-AiO-patch fixes for the Drakan Level Editor''s 3D View engine.'
CompanyName             equ     'Mechanist'
FileDescription         equ     'Level Editor''s 3D View patch DLL for the Drakan Community Patch'
LegalCopyright          equ     'Copyright ',0A9h,' 2018 Mechanist'
ProductName             equ     'Drakan Community Patch'



section '.code' code readable executable notpageable

include 'DSOUND_DLL_Entry.asm'

include 'DSOUND_Detours.asm'

include 'DSOUND_3DView_Engine_Patches.asm'

include 'String_Functions.asm'



section '.bss' data readable writeable notpageable

        hDSOUND            dd ?                                 ; handle to this DLL

        pRealDSOUNDFunc    rd 12                                ; because there are 12 exports in DSOUND.DLL

        szCurrentExePath   rb MAX_PATH + 1

        szRealDSOUNDPath   rb MAX_PATH + 1

        szScratchpad       rb 256                               ; some "scratchpad" space for string concatenations, etc.



section '.data' data readable writeable notpageable

        hOrgDSOUND         dd 0                                 ; handle to the real DSOUND.dll

        pRealDSOUNDFName1  dd szRealDSOUNDFunc1                 ; pointer table used by the GetProcAddress reimplementation
        pRealDSOUNDFName2  dd szRealDSOUNDFunc2
        pRealDSOUNDFName3  dd szRealDSOUNDFunc3
        pRealDSOUNDFName4  dd szRealDSOUNDFunc4
        pRealDSOUNDFName5  dd szRealDSOUNDFunc5
        pRealDSOUNDFName6  dd szRealDSOUNDFunc6
        pRealDSOUNDFName7  dd szRealDSOUNDFunc7
        pRealDSOUNDFName8  dd szRealDSOUNDFunc8
        pRealDSOUNDFName9  dd szRealDSOUNDFunc9
        pRealDSOUNDFName10 dd szRealDSOUNDFunc10
        pRealDSOUNDFName11 dd szRealDSOUNDFunc11
        pRealDSOUNDFName12 dd szRealDSOUNDFunc12

        pRealDSOUNDFAddr1  dd DirectSoundCreate                 ; pointer table used by the GetProcAddress reimplementation
        pRealDSOUNDFAddr2  dd DirectSoundEnumerateA
        pRealDSOUNDFAddr3  dd DirectSoundEnumerateW
        pRealDSOUNDFAddr4  dd DllCanUnloadNow
        pRealDSOUNDFAddr5  dd DllGetClassObject
        pRealDSOUNDFAddr6  dd DirectSoundCaptureCreate
        pRealDSOUNDFAddr7  dd DirectSoundCaptureEnumerateA
        pRealDSOUNDFAddr8  dd DirectSoundCaptureEnumerateW
        pRealDSOUNDFAddr9  dd GetDeviceID
        pRealDSOUNDFAddr10 dd DirectSoundFullDuplexCreate
        pRealDSOUNDFAddr11 dd DirectSoundCreate8
        pRealDSOUNDFAddr12 dd DirectSoundCaptureCreate8

        szValidExeName     db '\engine.exe',0                   ; must be all lowercase, and include the \
        szInvalidExeStrTxt db 'This version of DSOUND.dll can only be used with the Level Editor''s Engine.exe!',13,10,13,10,\
                              'It looks like your installation of Community Patch is corrupted - please try reinstalling it.',0
        szInvalidExeStrCap db 'Drakan Community Patch - DSOUND.dll error!',0

        szRealDSOUNDName   db '\DSOUND.dll',0
        szRealDSOUNDFunc1  db 'DirectSoundCreate',0
        szRealDSOUNDFunc2  db 'DirectSoundEnumerateA',0
        szRealDSOUNDFunc3  db 'DirectSoundEnumerateW',0
        szRealDSOUNDFunc4  db 'DllCanUnloadNow',0
        szRealDSOUNDFunc5  db 'DllGetClassObject',0
        szRealDSOUNDFunc6  db 'DirectSoundCaptureCreate',0
        szRealDSOUNDFunc7  db 'DirectSoundCaptureEnumerateA',0
        szRealDSOUNDFunc8  db 'DirectSoundCaptureEnumerateW',0
        szRealDSOUNDFunc9  db 'GetDeviceID',0
        szRealDSOUNDFunc10 db 'DirectSoundFullDuplexCreate',0
        szRealDSOUNDFunc11 db 'DirectSoundCreate8',0
        szRealDSOUNDFunc12 db 'DirectSoundCaptureCreate8',0



section '.rsrc' resource data readable notpageable

include 'Resources_section_kludge.asm'



section '.idata' import data readable notpageable

  library Kernel32,'KERNEL32.DLL',\
          User32, 'USER32.DLL'

  import  Kernel32,\
          DisableThreadLibraryCalls, 'DisableThreadLibraryCalls',\
          FreeLibrary, 'FreeLibrary',\
          GetCommandLineA, 'GetCommandLineA',\
          GetModuleFileNameA, 'GetModuleFileNameA',\
          GetProcAddress, 'GetProcAddress',\
          GetSystemDirectoryA, 'GetSystemDirectoryA',\
          GetTickCount, 'GetTickCount',\
          LoadLibraryA, 'LoadLibraryA',\
          VirtualProtect, 'VirtualProtect'

  import  User32,\
          MessageBoxA, 'MessageBoxA'



section '.edata' export data readable notpageable

  export 'DSOUND.DLL',\
         DirectSoundCreate, 'DirectSoundCreate',\
         DirectSoundEnumerateA, 'DirectSoundEnumerateA',\
         DirectSoundEnumerateW, 'DirectSoundEnumerateW',\
         DllCanUnloadNow, 'DllCanUnloadNow',\
         DllGetClassObject, 'DllGetClassObject',\
         DirectSoundCaptureCreate, 'DirectSoundCaptureCreate',\
         DirectSoundCaptureEnumerateA, 'DirectSoundCaptureEnumerateA',\
         DirectSoundCaptureEnumerateW, 'DirectSoundCaptureEnumerateW',\
         GetDeviceID, 'GetDeviceID',\
         DirectSoundFullDuplexCreate, 'DirectSoundFullDuplexCreate',\
         DirectSoundCreate8, 'DirectSoundCreate8',\
         DirectSoundCaptureCreate8, 'DirectSoundCaptureCreate8'



section '.reloc' fixups data readable notpageable discardable

  ; Fixup section. You don't have to
  ; put anything here manually.