;--------------- DLL entry function --------------------
proc DllEntryPoint, .hinstDLL, .fdwReason, .lpvReserved
begin

        call    GetEIP

        mov     eax,[.fdwReason]

        cmp     eax,DLL_PROCESS_ATTACH                          ; event sent right after the DLL is loaded
        je      .dll_attach

        ;cmp     eax,DLL_PROCESS_DETACH                          ; event sent right before the DLL is unloaded
        ;je      .dll_detach

        jmp     .exit


.dll_attach:                                                    ; library was loaded

        pushad

        stdcall [DisableThreadLibraryCalls], [.hinstDLL]        ; not interested in those

        stdcall [GetModuleFileNameA], 0, szCurrentExePath, MAX_PATH

        stdcall ConvertStrToLowercase, szCurrentExePath

        stdcall FindSubstrInStr, szCurrentExePath, szValidExeName

        test    eax,eax
        jnz     .nofail

        stdcall [MessageBoxA], 0, szInvalidExeStrTxt, szInvalidExeStrCap, 8240

        popad

        xor     eax,eax

        jmp     .exit                                           ; return 0 - DLL initialization failed!

.nofail:

        stdcall [GetSystemDirectoryA], szRealDSOUNDPath, MAX_PATH  ; returns length of string in EAX

        mov     esi,szRealDSOUNDName
        mov     edi,szRealDSOUNDPath
        mov     ecx,szRealDSOUNDName.size
        add     edi,eax
        rep     movsb                                           ; append the library name to the system directory path

        stdcall PatchDWord, 405C7Bh, 0C08B6690h                 ; patch in 3-byte NOP after the actual call, to get rid of the resulting broken opcode which the function will return to
        stdcall AddDetour, 405C77h, NewKeybindingsHandler, 0    ; patch in a call to the keybindings replacement code

        stdcall AddDetour, 469C8Dh, VisibleInvisibleTextures, 0  ; patch in a call to the code that makes invisible textures visible

        stdcall HookKernel32, [GetProcAddress], HookedGetProcAddress

        popad

        mov     eax,1                                           ; return 1, that means our library initialization was successful

.exit:

        return

endp


GetEIP:

        mov     eax,[esp]                                       ; retrieve the EIP
        sub     eax,1008h                                       ; correct for the length of the preceding opcodes at the start of DllEntryPoint + the PE header size
        mov     [hDSOUND],eax

        retn