; Detours/patching/proxy code for the DSOUND.dll

proc AddDetour, .PatchAddr, .TargetAddr, .IsJump

        .OldProtect     dd ?
        .pOldProtect    dd ?

begin

        pushad

        lea     eax,[.OldProtect]                               ; we need that pointer for the VirtualProtect calls
        mov     [.pOldProtect],eax

        mov     esi,[.PatchAddr]                                ; address of opcode to patch
        push    esi
        mov     edi,[.TargetAddr]                               ; jump/call target address
        sub     edi,esi
        sub     edi,5                                           ; corrected for the length of the long jump/call opcode

        stdcall [VirtualProtect], ESI, 5, PAGE_EXECUTE_READWRITE, [.pOldProtect]

        pop     ecx
        mov     eax,[.IsJump]
        add     eax,0E8h                                        ; 0E8h = CALL, 0E9h = JMP
        mov     [ecx],eax
        inc     ecx
        mov     [ecx],edi                                       ; assemble the opcode in place

        stdcall [VirtualProtect], ESI, 5, [.OldProtect], [.pOldProtect]

        popad

        return

endp


proc AddDragonDetour, .PatchOffset, .TargetAddr, .IsJump
begin

        mov     eax,[.PatchOffset]
        add     eax,[hDragon]                                   ; calculate the absolute address

        stdcall AddDetour, EAX, [.TargetAddr], [.IsJump]

        return

endp


proc PatchByte, .PatchAddr, .Byte

        .OldProtect     dd ?
        .pOldProtect    dd ?

begin

        pushad

        lea     eax,[.OldProtect]                               ; we need that pointer for the VirtualProtect calls
        mov     [.pOldProtect],eax

        mov     esi,[.PatchAddr]                                ; address of opcode to patch

        stdcall [VirtualProtect], ESI, 1, PAGE_EXECUTE_READWRITE, [.pOldProtect]

        mov     eax,[.Byte]
        mov     [esi],al

        stdcall [VirtualProtect], ESI, 1, [.OldProtect], [.pOldProtect]

        popad

        return

endp


proc PatchDragonByte, .PatchOffset, .Byte
begin

        mov     eax,[.PatchOffset]
        add     eax,[hDragon]                                   ; calculate the absolute address

        stdcall PatchByte, EAX, [.Byte]

        return

endp

proc PatchDWord, .PatchAddr, .DWord

        .OldProtect     dd ?
        .pOldProtect    dd ?

begin

        pushad

        lea     eax,[.OldProtect]                               ; we need that pointer for the VirtualProtect calls
        mov     [.pOldProtect],eax

        mov     esi,[.PatchAddr]                                ; address of opcode to patch

        stdcall [VirtualProtect], ESI, 4, PAGE_EXECUTE_READWRITE, [.pOldProtect]

        mov     eax,[.DWord]
        mov     [esi],eax

        stdcall [VirtualProtect], ESI, 4, [.OldProtect], [.pOldProtect]

        popad

        return

endp


proc PatchDragonDWord, .PatchOffset, .DWord
begin

        mov     eax,[.PatchOffset]
        add     eax,[hDragon]                                   ; calculate the absolute address

        stdcall PatchDWord, EAX, [.DWord]

        return

endp


proc HookKernel32, .PatchAddr, .TargetAddr

        .OldProtect     dd ?
        .pOldProtect    dd ?

begin

        pushad

        lea     eax,[.OldProtect]                               ; we need that pointer for the VirtualProtect calls
        mov     [.pOldProtect],eax

        mov     esi,[.PatchAddr]                                ; address of opcode to patch
        sub     esi,5                                           ; the hook needs to begin 5 bytes earlier, because of the JMP NEAR opcode

        push    esi

        mov     edi,[.TargetAddr]                               ; jump/call target address
        sub     edi,esi
        sub     edi,5                                           ; corrected for the length of the long jump opcode

        stdcall [VirtualProtect], ESI, 7, PAGE_EXECUTE_READWRITE, [.pOldProtect]

        pop     ecx

        mov     al,0E9h                                         ; JMP NEAR opcode
        mov     [ecx],al
        inc     ecx
        mov     [ecx],edi                                       ; the relative displacement

        add     ecx,4

        mov     ax,0F9EBh                                       ; JMP SHORT to the previous JMP NEAR opcode
        xchg    [ecx],ax                                        ; use XCHG instead of MOV, because it's guaranteed to be atomic

        stdcall [VirtualProtect], ESI, 7, [.OldProtect], [.pOldProtect]

        popad

        return

endp


proc LoadRealDSOUND
begin

        pushad

        stdcall [LoadLibraryA], szRealDSOUNDPath

        test    eax,eax
        jz     .fail

        mov     [hOrgDSOUND],eax                                ; we'll need that handle later...

        xor     esi,esi
        inc     esi                                             ; starting out with 1, since the ordinals are 1-based
        mov     edi,pRealDSOUNDFunc                             ; pointer to the pointer for the first ordinal

.loop:

        stdcall [GetProcAddress], [hOrgDSOUND], ESI             ; ordinals 1...12

        test    eax,eax
        jz      .fail

        mov     [edi],eax
        add     edi,4

        inc     esi

        cmp     esi,12                                          ; ordinals 1...12
        jbe     .loop

        popad

        xor     eax,eax

        return

.fail:

        popad

        mov     eax,1

        return

endp


proc HookedGetProcAddress, .hModule, .lpProcName
begin

        mov     eax,[.hModule]
        cmp     eax,[hDSOUND]
        je      .hooked                                         ; catch calls to GetProcAddr pertaining to this DLL, since those invariably fail for an unspecified reason...

        push    [.lpProcName]
        push    [.hModule]

        mov     eax,[GetProcAddress]
        add     eax,2
        call    eax                                             ; call GetProcAddr+2, to skip over the detour!

        return

.hooked:

        push    esi

        mov     ecx,12

.hooked_loop:

        mov     esi,pRealDSOUNDFName1 - 4                       ; needs the -4 because the loop counter is 1-based...
        lea     esi,[esi + ecx * 4]                             ; iterate over the list of export names

        push    ecx

        stdcall FindSubstrInStr, [ESI], [.lpProcName]

        pop     ecx

        test    eax,eax
        jz      .hooked_loop2                                   ; keep looking if there was no match this time

        mov     eax,pRealDSOUNDFAddr1 - 4                       ; needs the -4 because the loop counter is 1-based...
        mov     eax,[eax + ecx * 4]                             ; retrieve the procedure address

        jmp     .hooked_exit

.hooked_loop2:

        loop    .hooked_loop

        xor     eax,eax                                         ; return NULL if no match was found

.hooked_exit:

        pop     esi

        return

endp


;--------------- export functions ----------------------
align 4                                                         ; the alignment is theoretically not needed, but not doing this could cause unpredictable compatibility issues
proc DirectSoundCreate, .lpGuid, .ppDS, .pUnkOuter
begin

        mov     eax,[hOrgDSOUND]                                ; check if the real DSOUND.dll has already been loaded
        test    eax,eax
        jnz     .DSOUND_loaded
        call    LoadRealDSOUND

        test    eax,eax
        jz      .DSOUND_loaded

        mov     eax,80070057h                                   ; return DSERR_INVALIDPARAM (at least it fails in a well-defined manner...)

        return

.DSOUND_loaded:

        push    [.pUnkOuter]
        push    [.ppDS]
        push    [.lpGuid]
        mov     eax,[pRealDSOUNDFunc]
        call    eax                                             ; call the original function from the *real* DSOUND.dll

        return

endp


align 4
proc DirectSoundEnumerateA, .lpDSEnumCallback, .lpContext
begin

        mov     eax,[hOrgDSOUND]                                ; check if the real DSOUND.dll has already been loaded
        test    eax,eax
        jnz     .DSOUND_loaded
        call    LoadRealDSOUND

        test    eax,eax
        jz      .DSOUND_loaded

        mov     eax,80070057h                                   ; return DSERR_INVALIDPARAM (at least it fails in a well-defined manner...)

        return

.DSOUND_loaded:

        push    [.lpContext]
        push    [.lpDSEnumCallback]
        mov     eax,[pRealDSOUNDFunc + 1 * 4]
        call    eax                                             ; call the original function from the *real* DSOUND.dll

        return

endp


align 4
proc DirectSoundEnumerateW, .lpDSEnumCallback, .lpContext
begin

        mov     eax,[hOrgDSOUND]                                ; check if the real DSOUND.dll has already been loaded
        test    eax,eax
        jnz     .DSOUND_loaded
        call    LoadRealDSOUND

        test    eax,eax
        jz      .DSOUND_loaded

        mov     eax,80070057h                                   ; return DSERR_INVALIDPARAM (at least it fails in a well-defined manner...)

        return

.DSOUND_loaded:

        push    [.lpContext]
        push    [.lpDSEnumCallback]
        mov     eax,[pRealDSOUNDFunc + 2 * 4]
        call    eax                                             ; call the original function from the *real* DSOUND.dll

        return

endp

align 4
proc DllCanUnloadNow
begin

        xor     eax,eax
        inc     eax                                             ; always return S_FALSE: we can never be unloaded until the parent process unloads

        return

endp


align 4
proc DllGetClassObject, .rclsid, .riid, .ppv
begin

        mov     eax,[hOrgDSOUND]                                ; check if the real DSOUND.dll has already been loaded
        test    eax,eax
        jnz     .DSOUND_loaded
        call    LoadRealDSOUND

        test    eax,eax
        jz      .DSOUND_loaded

	mov     eax,80040111h                                   ; return E_CLASSNOTAVAILABLE (at least it fails in a well-defined manner...)

        return

.DSOUND_loaded:

        push    [.ppv]
        push    [.riid]
        push    [.rclsid]
        mov     eax,[pRealDSOUNDFunc + 4 * 4]
        call    eax                                             ; call the original function from the *real* DSOUND.dll

        return

endp


align 4
proc DirectSoundCaptureCreate, .lpcGuid, .ppDSC, .pUnkOuter
begin

        mov     eax,[hOrgDSOUND]                                ; check if the real DSOUND.dll has already been loaded
        test    eax,eax
        jnz     .DSOUND_loaded
        call    LoadRealDSOUND

        test    eax,eax
        jz      .DSOUND_loaded

        mov     eax,80070057h                                   ; return DSERR_INVALIDPARAM (at least it fails in a well-defined manner...)

        return

.DSOUND_loaded:

        push    [.pUnkOuter]
        push    [.ppDSC]
        push    [.lpcGuid]
        mov     eax,[pRealDSOUNDFunc + 5 * 4]
        call    eax                                             ; call the original function from the *real* DSOUND.dll

        return

endp


align 4
proc DirectSoundCaptureEnumerateA, .lpDSEnumCallback, .lpContext
begin

        mov     eax,[hOrgDSOUND]                                ; check if the real DSOUND.dll has already been loaded
        test    eax,eax
        jnz     .DSOUND_loaded
        call    LoadRealDSOUND

        test    eax,eax
        jz      .DSOUND_loaded

        mov     eax,80070057h                                   ; return DSERR_INVALIDPARAM (at least it fails in a well-defined manner...)

        return

.DSOUND_loaded:

        push    [.lpContext]
        push    [.lpDSEnumCallback]
        mov     eax,[pRealDSOUNDFunc + 6 * 4]
        call    eax                                             ; call the original function from the *real* DSOUND.dll

        return

endp


align 4
proc DirectSoundCaptureEnumerateW, .lpDSEnumCallback, .lpContext
begin

        mov     eax,[hOrgDSOUND]                                ; check if the real DSOUND.dll has already been loaded
        test    eax,eax
        jnz     .DSOUND_loaded
        call    LoadRealDSOUND

        test    eax,eax
        jz      .DSOUND_loaded

        mov     eax,80070057h                                   ; return DSERR_INVALIDPARAM (at least it fails in a well-defined manner...)

        return

.DSOUND_loaded:

        push    [.lpContext]
        push    [.lpDSEnumCallback]
        mov     eax,[pRealDSOUNDFunc + 7 * 4]
        call    eax                                             ; call the original function from the *real* DSOUND.dll

        return

endp


align 4
proc GetDeviceID, .pGuidSrc, .pGuidDest
begin

        mov     eax,[hOrgDSOUND]                                ; check if the real DSOUND.dll has already been loaded
        test    eax,eax
        jnz     .DSOUND_loaded
        call    LoadRealDSOUND

        test    eax,eax
        jz      .DSOUND_loaded

        mov     eax,80070057h                                   ; return DSERR_INVALIDPARAM (at least it fails in a well-defined manner...)

        return

.DSOUND_loaded:

        push    [.pGuidDest]
        push    [.pGuidSrc]
        mov     eax,[pRealDSOUNDFunc + 8 * 4]
        call    eax                                             ; call the original function from the *real* DSOUND.dll

        return

endp


align 4
proc DirectSoundFullDuplexCreate, .pcGuidCaptureDevice, .pcGuidRenderDevice, .pcDSCBufferDesc, .pcDSBufferDesc, .hWnd, .dwLevel, .ppDSFD, .ppDSCBuffer8, .ppDSBuffer8, .pUnkOuter
begin

        mov     eax,[hOrgDSOUND]                                ; check if the real DSOUND.dll has already been loaded
        test    eax,eax
        jnz     .DSOUND_loaded
        call    LoadRealDSOUND

        test    eax,eax
        jz      .DSOUND_loaded

        mov     eax,80070057h                                   ; return DSERR_INVALIDPARAM (at least it fails in a well-defined manner...)

        return

.DSOUND_loaded:

        push    [.pUnkOuter]
        push    [.ppDSBuffer8]
        push    [.ppDSCBuffer8]
        push    [.ppDSFD]
        push    [.dwLevel]
        push    [.hWnd]
        push    [.pcDSBufferDesc]
        push    [.pcDSCBufferDesc]
        push    [.pcGuidRenderDevice]
        push    [.pcGuidCaptureDevice]
        mov     eax,[pRealDSOUNDFunc + 9 * 4]
        call    eax                                             ; call the original function from the *real* DSOUND.dll

        return

endp


align 4
proc DirectSoundCreate8, .lpcGuidDevice, .ppDS8, .pUnkOuter
begin

        mov     eax,[hOrgDSOUND]                                ; check if the real DSOUND.dll has already been loaded
        test    eax,eax
        jnz     .DSOUND_loaded
        call    LoadRealDSOUND

        test    eax,eax
        jz      .DSOUND_loaded

        mov     eax,80070057h                                   ; return DSERR_INVALIDPARAM (at least it fails in a well-defined manner...)

        return

.DSOUND_loaded:

        push    [.pUnkOuter]
        push    [.ppDS8]
        push    [.lpcGuidDevice]
        mov     eax,[pRealDSOUNDFunc + 10 * 4]
        call    eax                                             ; call the original function from the *real* DSOUND.dll

        return

endp


align 4
proc DirectSoundCaptureCreate8, .lpcGuidDevice, .lplpDSC, .pUnkOuter
begin

        mov     eax,[hOrgDSOUND]                                ; check if the real DSOUND.dll has already been loaded
        test    eax,eax
        jnz     .DSOUND_loaded
        call    LoadRealDSOUND

        test    eax,eax
        jz      .DSOUND_loaded

        mov     eax,80070057h                                   ; return DSERR_INVALIDPARAM (at least it fails in a well-defined manner...)

        return

.DSOUND_loaded:

        push    [.pUnkOuter]
        push    [.lplpDSC]
        push    [.lpcGuidDevice]
        mov     eax,[pRealDSOUNDFunc + 11 * 4]
        call    eax                                             ; call the original function from the *real* DSOUND.dll

        return

endp